_ikona-cli() {
    local i cur prev opts cmds
    COMPREPLY=()
    cur="${COMP_WORDS[COMP_CWORD]}"
    prev="${COMP_WORDS[COMP_CWORD-1]}"
    cmd=""
    opts=""

    for i in ${COMP_WORDS[@]}
    do
        case "${i}" in
            ikona-cli)
                cmd="ikona-cli"
                ;;
            
            class)
                cmd+="__class"
                ;;
            convert)
                cmd+="__convert"
                ;;
            extract)
                cmd+="__extract"
                ;;
            help)
                cmd+="__help"
                ;;
            optimize)
                cmd+="__optimize"
                ;;
            *)
                ;;
        esac
    done

    case "${cmd}" in
        ikona-cli)
            opts=" -h -V  --help --version   optimize class convert extract help"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 1 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        
        ikona__cli__class)
            opts=" -i -h -V -m  --inplace --help --version --mode  <input> <output> "
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 2 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                
                --mode)
                    COMPREPLY=($(compgen -W "light dark" -- "${cur}"))
                    return 0
                    ;;
                    -m)
                    COMPREPLY=($(compgen -W "light dark" -- "${cur}"))
                    return 0
                    ;;
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        ikona__cli__convert)
            opts=" -i -h -V -t  --inplace --help --version --target  <input> <output> "
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 2 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                
                --target)
                    COMPREPLY=($(compgen -W "light dark" -- "${cur}"))
                    return 0
                    ;;
                    -t)
                    COMPREPLY=($(compgen -W "light dark" -- "${cur}"))
                    return 0
                    ;;
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        ikona__cli__extract)
            opts=" -h -V  --help --version  <input> <size> <output> "
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 2 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        ikona__cli__help)
            opts=" -h -V  --help --version  "
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 2 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        ikona__cli__optimize)
            opts=" -i -h -V -m  --inplace --help --version --mode  <input> <output> "
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 2 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                
                --mode)
                    COMPREPLY=($(compgen -W "all rsvg scour" -- "${cur}"))
                    return 0
                    ;;
                    -m)
                    COMPREPLY=($(compgen -W "all rsvg scour" -- "${cur}"))
                    return 0
                    ;;
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
    esac
}

complete -F _ikona-cli -o bashdefault -o default ikona-cli
